.NOLIST
.586
.model flat,stdcall
option casemap:none
include	\masm32\include\windows.inc

Rand32		proto	:DWORD
InitRand32	proto   :DWORD

.data?
seed	dd	?

.code
DllEntry	proc	hinstance:HINSTANCE, reason:DWORD, reserved1:DWORD
		invoke  InitRand32,0
		mov	eax,TRUE
		ret
DllEntry	endp

;Usage: RandomIntArray(Data:pointer,count:int,base:int,seed:int),int
;Returns a series of random integers, base>n>=0, to a dword array.  If seed=0, the
;CPU clock is used for random seeding.  Otherwise, a given seed will reproduce the
;same sequence.
RandomIntArray	proc uses esi pData:PTR DWORD, count:DWORD, base:DWORD, sede:dword
	invoke  InitRand32,sede
	mov     esi,pData
	mov     ecx,count
	mov     edx,base
@@:	or      ecx,ecx
	jz      @F
	push    ecx
	push    edx
	invoke  Rand32,edx
	pop     edx
	pop     ecx
	mov     [esi],eax
	add     esi,4
	dec     ecx
	jmp     @B
@@:	ret
RandomIntArray  endp

;Usage: InitRand32(seed:int)
;Sets a starting seed for random number generation.  Valid values range 1 
;through 7ffffffe.  An input value of zero uses the cpu time-stamp clock 
;as a 'randomize' option.  Values greater than 7ffffffe are ignored and 
;the seed is unchanged.  A negative seed avoids reseeding, allowing queries
;without changes.  The function returns the current seed and sets the Z flag 
;if this equals the requested input seed.
;
InitRand32	proc	new_seed:DWORD
	mov	eax,new_seed	;valid seeds range 1 thru 7ffffffeh
	test	eax,eax
	jnz	ir01		;If non-zero seed specified
@@:	rdtsc			; else get value from CPU clock
	and	eax,7fffffffh	; and clear msbit for a valid seed
	jz	@B		;IF TSC seed just happens to be 0 then retry

ir01:	cmp	eax,7fffffffh	;If seed > 7ffffffe, no changes
	jb	@F
	mov	eax,seed
@@:	mov	seed,eax
	cmp	eax,new_seed	;set flags returned for possible testing
	ret			;return seed value
InitRand32	endp

Rand32	proc	base:DWORD
	mov	eax,base		;valid values 1 thru 7fffffff
	test	eax,eax
	jle	@F			;skip if base <= 0 (invalid)
	mov	eax,seed    
	mov	ecx,16807		;a = 7^5
	mul	ecx			;edx:eax == a*seed
	mov	ecx,7fffffffh
	div	ecx
	mov	eax,edx			;(a*seed) % 7fffffff
	mov	seed,eax		;save next seed 
	mov	ecx,base
	shl	eax,1
	mul	ecx
	mov	eax,edx
	ret

@@:	or	eax,-1			;if base error, return -1
	ret				; and set S flag.
Rand32	endp

End DllEntry
